#ifndef _GROUP_NODE_H_
#define _GROUP_NODE_H_

#include <vector>
#include "cglib/scene_graph_node.h"
#include "cglib/reference.h"

//! Represent a group of scene graph nodes as a single node.
class GroupNode : public SceneGraphNode
{
public:
    //! A constructor that does nothing.
    GroupNode ();
    
    //! A destructor that does nothing.
    virtual ~GroupNode ();
    
    //! Return the number of children.
    int get_children_count() const;
    
    //! Return the child with the given index.
    SceneGraphNode *get_child(int index);
    
    //! Add the given scene graph node to the end of the list of children.
    void append_child(SceneGraphNode *child);
    
    //! Accept a visitor.
    virtual void accept(SceneGraphNodeVisitor *visitor);

private:
    std::vector< Reference<SceneGraphNode> > children; //! the list of children
};

#endif /* _GROUP_NODE_H_ */
