#ifndef _MATERIAL_VISITOR_H_
#define _MATERIAL_VISITOR_H_

#include "cglib/phong_material.h"
#include "cglib/textured_phong_material.h"

//! Represent a visitor that visits objects of class Material.
class MaterialVisitor
{
public:
    //! Visit an object of class Material.
    void visit(Material *material);
    
    //! Visit an object of class PhongMaterial.
    virtual void visit_PhongMaterial(PhongMaterial *material);

	//! Visit an object of class TexturedPhongMaterial.
	virtual void visit_TexturedPhongMaterial(TexturedPhongMaterial *material);
};

#endif /* _MATERIAL_VISITOR_H_ */
