#ifndef _PHONG_MATERIAL_H_
#define _PHONG_MATERIAL_H_

#include "cglib/material.h"
#include "cglib/rgba.h"

//! Represent a material based on Phong lighting model.
class PhongMaterial : public Material
{
public:
    //! A constructor that sets all colors to black and shininess to 0.
    PhongMaterial ();
    
    //! A destructor that does nothing.
    virtual ~PhongMaterial ();
    
    Rgba ambient;    //!< the ambient color (ka)
    Rgba diffuse;    //!< the diffuse color (kd)
    Rgba specular;   //!< the specular color (ks)
    float shininess; //! the shininess (n)
    
    virtual void apply(MaterialVisitor *visitor);
};

#endif /* _PHONG_MATERIAL_H_ */
