#ifndef _SCENE_GRAPH_NODE_VISITOR_H_
#define _SCENE_GRAPH_NODE_VISITOR_H_

#include "cglib/scene_graph_node.h"
#include "cglib/mesh_node.h"
#include "cglib/transform_node.h"
#include "cglib/group_node.h"

//! Represent a visitor to objects of class SceneGraphNode.
class SceneGraphNodeVisitor
{
public:
	//! Visit an object of type SceneGraphNode.
    void visit(SceneGraphNode *node);

	//! Visit an object of type MeshNode.
	virtual void visit_MeshNode(MeshNode *node) = 0;

	//! Visit an object of type TransformNode.
	virtual void visit_TransformNode(TransformNode *node) = 0;

	//! Visit an object of type GroupNode.
	virtual void visit_GroupNode(GroupNode *node) = 0;
};

#endif /* _SCENE_GRAPH_NODE_VISITOR_H_ */
