#ifndef _TEXTURE_H_
#define _TEXTURE_H_

#ifdef _WIN32
#include <windows.h>
#endif

#include <string>
#include <GL/gl.h>
#include "cglib/reference_counted.h"

//! Represent an OpenGL texture.
class Texture : public ReferenceCounted
{
public:
    //! A constructor that does nothing.
    Texture ();
    
    //! Destroy the texture.
    virtual ~Texture ();
    
    //! Load a texture from the given file name.
    void load(const char *file_name);
    
    //! Bind the texture before use.
    void bind();
    
private:
	GLuint texture_id;     //!< the ID of the OpenGL texture
	std::string file_name; //!< the name of the file from which the texture was loaded
};

#endif /* _TEXTURE_H_ */
