#ifndef _TEXTURED_PHONG_MATERIAL_H_
#define _TEXTURED_PHONG_MATERIAL_H_

#include "cglib/phong_material.h"
#include "cglib/reference.h"
#include "cglib/texture.h"

class MaterialVisitor;

//! Represent a Phong material with texture
class TexturedPhongMaterial : public PhongMaterial
{
public:
    //! Initialize the texture to NULL, all the colors to black, and shininess to 1.
    TexturedPhongMaterial();
    
    //! Destroy the meterial.
    virtual ~TexturedPhongMaterial();

	virtual void accept(MaterialVisitor *visitor);

    Reference<Texture> texture; //!< the texture.
};

#endif /* _TEXTURED_PHONG_MATERIAL_H_ */
